SystemOrganization addCategory: #'Voyage-Mongo-Core'!

Trait named: #TJSON
	uses: {}
	category: 'Voyage-Mongo-Core'!

!TJSON classSide methodsFor: 'instance creation' stamp: 'EstebanLorenzano 9/27/2011 17:35'!
fromJSON: aDictionary 
	^self basicNew 
		fromJSON: aDictionary;
		yourself! !

!TJSON methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/28/2011 22:12'!
asJSON 
	^VOMongoSerializerOLD objectToJSON: self.! !

!TJSON methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/28/2011 22:12'!
asShallowJSON
	^VOMongoSerializerOLD objectToShallowJSON: self! !

!TJSON methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/28/2011 22:12'!
fromJSON: aDictionary 
	VOMongoSerializerOLD 
		fromJSON: aDictionary
		toObject: self! !

VORepository subclass: #VOMongoRepository
	instanceVariableNames: 'root database collections cache refreshCache descriptionBuilder materializer serializer port databaseName host useTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Core'!

!VOMongoRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/29/2012 18:13'!
database: databaseString
	^self 
		host: self defaultHost 
		port: self defaultPort
		database: databaseString! !

!VOMongoRepository class methodsFor: 'defaults' stamp: 'EstebanLorenzano 1/29/2012 18:10'!
defaultHost
	^'localhost'! !

!VOMongoRepository class methodsFor: 'defaults' stamp: 'EstebanLorenzano 1/29/2012 18:08'!
defaultPort
	^27017! !

!VOMongoRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/29/2012 18:13'!
host: hostString database: databaseString
	^self 
		host: hostString 
		port: self defaultPort
		database: databaseString! !

!VOMongoRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/29/2012 18:12'!
host: hostString port: portNumber database: databaseString
	^self basicNew 
		initializeHost: hostString 
			port: portNumber 
			database: databaseString;
		yourself! !

!VOMongoRepository class methodsFor: 'initialization' stamp: 'EstebanLorenzano 3/5/2012 12:37'!
initialize 
	"self register."
	! !

!VOMongoRepository class methodsFor: 'initialization' stamp: 'EstebanLorenzano 9/23/2011 17:32'!
register 
	"VOMongoRepository register"
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!VOMongoRepository class methodsFor: 'system startup' stamp: 'EstebanLorenzano 9/23/2011 17:19'!
shutDown: quitting
	quitting
		ifTrue: [ self current shutDown ]! !

!VOMongoRepository class methodsFor: 'system startup' stamp: 'EstebanLorenzano 9/23/2011 17:19'!
startUp: resumming
	resumming 
		ifTrue: [ self current startUp ]! !

!VOMongoRepository class methodsFor: 'initialization' stamp: 'EstebanLorenzano 10/19/2011 15:59'!
unregister
	"VOMongoDBRepository unregister"
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.! !

!VOMongoRepository class methodsFor: 'testing' stamp: 'EstebanLorenzano 12/14/2011 11:16'!
validateConectionHost: host port: port
	| mongo |
	
	mongo :=  Mongo host: host port: port.
	^[ mongo open; close. true ] 
	on: Error 
	do: [ :e | false ]! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 9/27/2011 17:17'!
cache
	^cache! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 9/27/2011 17:18'!
cacheAt: anOID
	^self cache at: anOID! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 9/27/2011 17:42'!
cacheAt: anOID put: anObject
	self cache 
		at: anOID 
		put: anObject! !

!VOMongoRepository methodsFor: 'private mongo' stamp: 'EstebanLorenzano 10/12/2011 09:58'!
collectionAt: aClass
	| collectionName |
	collectionName := self collectionNameFor: aClass.
	 ^collections 
		at: collectionName
		ifAbsentPut: [ database addCollection: collectionName ]! !

!VOMongoRepository methodsFor: 'private mongo' stamp: 'EstebanLorenzano 10/29/2011 15:54'!
collectionNameFor: aClass
	^(self descriptionBuilder for: aClass) collectionName! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 9/23/2011 21:59'!
commit: aBlock 
	aBlock value.! !

!VOMongoRepository methodsFor: 'private mongo' stamp: 'EstebanLorenzano 9/23/2011 18:48'!
createAndOpenRoot 
	^self createRoot 
		open;
		yourself! !

!VOMongoRepository methodsFor: 'private mongo' stamp: 'EstebanLorenzano 9/23/2011 17:26'!
createRoot 
	^Mongo host: self host port: self port ! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 11/23/2011 13:43'!
database 
	^database! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/29/2012 18:16'!
databaseName
	^databaseName! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 14:52'!
descriptionBuilder
	^descriptionBuilder ifNil: [ descriptionBuilder := VOMongoDescriptionBuilder new ]! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/14/2012 17:46'!
descriptionFor: aClass
	^self descriptionBuilder build: aClass! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 9/24/2011 08:25'!
ensureConnection 
	root isOpen 
		ifFalse: [ self initializeMongoDB ]! !

!VOMongoRepository methodsFor: 'private executing' stamp: 'EstebanLorenzano 10/27/2011 17:59'!
execute: aBlock
	| oldRefreshCacheStatus |
	oldRefreshCacheStatus := refreshCache.
	[ refreshCache := false.
	  ^self execute: aBlock retries: 1 ]
	ensure: [ refreshCache := oldRefreshCacheStatus ]! !

!VOMongoRepository methodsFor: 'private executing' stamp: 'EstebanLorenzano 10/29/2011 11:26'!
execute: aBlock retries: retriesLeft
	aBlock 
		on: Error 
		do: [ :e | 
			(self isRecoverableError: e)
				ifTrue: [ self recoverFromError: e ].
			((self isRetryError: e) and: [ retriesLeft > 0 ])
				ifTrue: [ self execute: aBlock retries: retriesLeft - 1 ]
				ifFalse: [ VOMongoError signal: e messageText ] ]! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/29/2012 18:14'!
host 
	^host! !

!VOMongoRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 3/3/2012 14:52'!
initialize 
	super initialize.
	refreshCache := true.
	self initializeMongoDB.
	self initializeCache.! !

!VOMongoRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 10/26/2011 10:42'!
initializeCache
	cache := VOMongoCache new.! !

!VOMongoRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/29/2012 18:14'!
initializeHost: hostString port: portNumber database: databaseString
	host := hostString.
	port := portNumber.
	databaseName := databaseString.
	self initialize! !

!VOMongoRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 10/6/2011 18:14'!
initializeMongoDB 
	root := self createAndOpenRoot.
	database := self openDatabase.
	collections := Dictionary new.! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 3/4/2012 19:36'!
insert: anObject serialized: jsonDictionary withId: aOID
	(self collectionAt: anObject class) 
		add: (jsonDictionary
			at: '_id' put: aOID;
			yourself).

	^aOID! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 10/29/2011 09:50'!
insert: anObject withId: aOID
	(self collectionAt: anObject class) add: ((self serializer serialize: anObject)
		at: '_id' put: aOID;
		yourself).

	^aOID! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 10/11/2011 20:25'!
internalRawSelectMany: aClass where: aDictionary
	^(self collectionAt: aClass) select: aDictionary
! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 3/4/2012 19:35'!
internalSave: anObject
	| id serialized |
	
	serialized := self serializer serialize: anObject.
	id := (self keyOf: anObject) 
		ifNotNil: [ : theId | 
			self 
				update: anObject 
				serialized: serialized 
				withId: theId ]
		ifNil: [ 
			self 
				insert: anObject
				serialized: serialized 
				withId: OID nextOID ].
	
	self cacheAt: id put: anObject.! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 10/7/2011 19:32'!
internalSelectMany: aClass where: aDictionary
	| results |
	
	results := self class collectionClass new.
	((self collectionAt: aClass) 
		select: aDictionary) 
		do: [ :each | results add: (self retrieveObjectOf: aClass json: each) ].
			
	^results! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 10/7/2011 19:32'!
internalSelectOne: aClass where: aDictionary
	| json result |
	
	json := (self collectionAt: aClass) detect: aDictionary.
	json isEmptyOrNil 
		ifFalse: [ result := self retrieveObjectOf: aClass json: json ].
			
	^result! !

!VOMongoRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 9/27/2011 20:42'!
isAvailable
	[ self ensureConnection ] 
	on: Error 
	do: [ :e | Transcript show: e messageText ].
	^root isOpen! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 1/29/2012 20:16'!
isNew: anObject 
	^(self keyOf: anObject) isNil! !

!VOMongoRepository methodsFor: 'private testing' stamp: 'EstebanLorenzano 1/6/2012 10:55'!
isRecoverableError: anError
	^{ NetworkError. BSONError. MessageNotUnderstood. PrimitiveFailed } anySatisfy: [ :each | anError isKindOf: each ]! !

!VOMongoRepository methodsFor: 'private testing' stamp: 'EstebanLorenzano 1/6/2012 10:55'!
isRetryError: anError
	^{ NetworkError. MessageNotUnderstood. PrimitiveFailed } anySatisfy: [ :each | anError isKindOf: each ]! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:27'!
keyOf: anObject 
	^self keyOf: anObject ifAbsent: [ nil ]! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:28'!
keyOf: anObject ifAbsent: aBlock
	^self cache 
		keyAtValue: anObject 
		ifAbsent: aBlock! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 10/29/2011 09:48'!
materializer 
	^materializer ifNil: [ materializer := VOMongoMaterializer repository: self ]! !

!VOMongoRepository methodsFor: 'private mongo' stamp: 'EstebanLorenzano 9/23/2011 17:27'!
openDatabase 
	^root databaseNamed: self databaseName! !

!VOMongoRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/29/2012 18:14'!
port 
	^port! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/26/2011 09:36'!
rawSelectMany: aClass where: aDictionary
	self execute: [ 
		^self internalRawSelectMany: aClass where: aDictionary ]! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 11/3/2011 11:36'!
recoverFromError: anError 
	Smalltalk 
		logError: anError messageText
		inContext: anError signalerContext.
	[ root close ] 
	on: Error do: [ :e| self flag: #todo. "Do nothing" ].
	self initializeMongoDB. ! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2011 15:58'!
remove: anObject 
	self execute: [
		(self collectionAt: anObject class) delete: (self serializer serialize: anObject) ]! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/26/2011 09:36'!
removeAll: aClass 
	self execute: [
		(self collectionAt: aClass) drop.
		self removeCollection: aClass ].! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 10/12/2011 09:57'!
removeCollection: aClass
	collections removeKey: (self collectionNameFor: aClass)! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 12/13/2011 09:49'!
retrieveObjectOf: aClass json: aDictionary
	| id object | 
	
	aDictionary at: '$err' ifPresent: [ :message | VOMongoError signal: message ].
	id := aDictionary at: '_id'.
	object := self cacheAt: id.
	(refreshCache or: [ object isNil ])
		ifTrue: [
			object ifNil: [ object := aClass basicNew ].
			self cacheAt: id put: object.
			self materializer 
				materialize: object 
				fromJSON: aDictionary ].
	^object! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/26/2011 09:36'!
save: anObject	
	self execute: [
		self internalSave: anObject ]! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 9/23/2011 19:24'!
selectAll: aClass 
	^self 
		selectMany: aClass 
		where: Dictionary new! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 3/4/2012 19:44'!
selectMany: aClass where: aDictionary
	| selected |
	self execute: [ 
		selected := self internalSelectMany: aClass where: aDictionary.
		^aClass = aClass persistentClass
			ifTrue: [ selected ]
			ifFalse: [ selected select: [ :each | each isKindOf: aClass ] ] ]! !

!VOMongoRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/26/2011 09:36'!
selectOne: aClass where: aDictionary
	self execute: [ 
		^self internalSelectOne: aClass where: aDictionary ]! !

!VOMongoRepository methodsFor: 'private accessing' stamp: 'EstebanLorenzano 3/4/2012 21:37'!
serializer
	^serializer ifNil: [ serializer := VOMongoSerializer repository: self ]! !

!VOMongoRepository methodsFor: 'system startup' stamp: 'EstebanLorenzano 9/23/2011 17:24'!
shutDown
	! !

!VOMongoRepository methodsFor: 'system startup' stamp: 'EstebanLorenzano 11/7/2011 18:54'!
startUp
	self initializeCache.
	self initializeMongoDB.! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 3/4/2012 19:34'!
update: anObject serialized: jsonDictionary withId: aOID
	(self collectionAt: anObject class) 
		replace: (Dictionary with: '_id'->aOID)
		with: (jsonDictionary
			at: '_id' put: aOID;
			yourself).
	
	^aOID! !

!VOMongoRepository methodsFor: 'private persistence' stamp: 'EstebanLorenzano 10/29/2011 09:51'!
update: anObject withId: aOID
	(self collectionAt: anObject class) 
		replace: (Dictionary with: '_id'->aOID)
		with: ((self serializer serialize: anObject)
			at: '_id' put: aOID;
			yourself).
	
	^aOID! !

ProtoObject subclass: #LazyProxy
	instanceVariableNames: 'objectClass objectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Core'!

!LazyProxy class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 10/26/2011 12:32'!
objectClass: aClass id: anObject
	^self basicNew 
		initializeClass: aClass id: anObject! !

!LazyProxy methodsFor: 'system primitives' stamp: 'EstebanLorenzano 10/26/2011 19:26'!
becomeForward: otherObject 
	"Primitive. All variables in the entire system that used to point
	to the receiver now point to the argument.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)! !

!LazyProxy methodsFor: 'system primitives' stamp: 'EstebanLorenzano 10/26/2011 19:27'!
doesNotUnderstand: aMessage 
	| realObject |
	
	realObject := objectClass selectOne: (Dictionary with: '_id'->objectId).
	realObject ifNil: [ Error signal: 'Invalid lazy conversion' ].
	
	self becomeForward: realObject.
	^realObject
		perform: aMessage selector 
		withArguments: aMessage arguments.! !

!LazyProxy methodsFor: 'initialization' stamp: 'EstebanLorenzano 10/26/2011 12:33'!
initializeClass: aClass id: anObject
	objectClass := aClass.
	objectId := anObject.! !

ProtoObject subclass: #VOLazyProxy
	instanceVariableNames: 'repository objectClass objectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Core'!

!VOLazyProxy class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 3/4/2012 14:48'!
objectClass: aClass id: anObject
	^self repository: nil objectClass: aClass id: anObject! !

!VOLazyProxy class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 3/4/2012 20:24'!
repository: aRepository objectClass: aClass id: idObject
	^self basicNew 
		initializeRepository: aRepository 
			class: aClass 
			id: idObject! !

!VOLazyProxy methodsFor: 'system primitives' stamp: 'EstebanLorenzano 3/4/2012 14:48'!
becomeForward: otherObject 
	"Primitive. All variables in the entire system that used to point
	to the receiver now point to the argument.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)! !

!VOLazyProxy methodsFor: 'system primitives' stamp: 'EstebanLorenzano 3/4/2012 20:24'!
doesNotUnderstand: aMessage 
	| realObject |
	
	realObject := self repository 
		selectOne: objectClass 
		where: (Dictionary with: '_id'->objectId).
	realObject ifNil: [ Error signal: 'Invalid lazy conversion' ].
	
	self becomeForward: realObject.
	^realObject
		perform: aMessage selector 
		withArguments: aMessage arguments.! !

!VOLazyProxy methodsFor: 'initialization' stamp: 'EstebanLorenzano 3/4/2012 20:24'!
initializeRepository: aRepository class: aClass id: idObject
	repository := aRepository.
	objectClass := aClass.
	objectId := idObject.! !

!VOLazyProxy methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/4/2012 14:48'!
repository 
	^repository ifNil: [ VORepository repository ]! !

Object subclass: #VOMongoCache
	instanceVariableNames: 'compactLimit objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Core'!

!VOMongoCache class methodsFor: 'defaults' stamp: 'EstebanLorenzano 9/27/2011 16:56'!
defaultCompactLimit 
	^8000! !

!VOMongoCache class methodsFor: 'defaults' stamp: 'EstebanLorenzano 9/27/2011 17:04'!
maximumCompactLimit 
	^25000! !

!VOMongoCache class methodsFor: 'defaults' stamp: 'EstebanLorenzano 9/27/2011 17:04'!
minimumCompactLimit 
	^2000! !

!VOMongoCache methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
at: anOID
	^objects 
		at: anOID 
		ifAbsent: [ nil ]! !

!VOMongoCache methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
at: anOID put: anObject 
	self compactIfNeeded.
	objects at: anOID put: anObject.! !

!VOMongoCache methodsFor: 'private' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
compactIfNeeded 
	objects size > self compactLimit
		ifTrue: [ 
			self performCompact. 
			self recalculateCompactLimit ]! !

!VOMongoCache methodsFor: 'private' stamp: 'EstebanLorenzano 9/27/2011 16:56'!
compactLimit 
	^compactLimit ifNil: [ compactLimit := self class defaultCompactLimit ]! !

!VOMongoCache methodsFor: 'private' stamp: 'EstebanLorenzano 9/27/2011 17:03'!
compactLimit: aNumber
	compactLimit := aNumber! !

!VOMongoCache methodsFor: 'initialization' stamp: 'EstebanLorenzano 9/27/2011 17:37'!
initialize 
	super initialize.
	self resetCache.! !

!VOMongoCache methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:27'!
keyAtValue: anObject
	^self keyAtValue: anObject ifAbsent: [ nil ]! !

!VOMongoCache methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
keyAtValue: anObject ifAbsent: aBlock
	^objects
		keyAtValue: anObject 
		ifAbsent: aBlock! !

!VOMongoCache methodsFor: 'private' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
performCompact 
	| deadKeys |
	
	deadKeys := Set new.
	objects keysAndValuesDo:  [ :key :value | 
		value ifNil: [ deadKeys add: key ] ].
	deadKeys do: [ :each | objects removeKey: each ].
	objects compact
	! !

!VOMongoCache methodsFor: 'printing' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
printOn: aStream
	aStream 
		nextPutAll: 'Cache';
		nextPut: $(;
		nextPutAll: objects size asString;
		space;
		nextPutAll: 'objects';
		nextPut: $).! !

!VOMongoCache methodsFor: 'private' stamp: 'EstebanLorenzano 12/13/2011 11:02'!
recalculateCompactLimit 
	| occupiedPercent newSize |
	occupiedPercent := (objects size * 100) / self compactLimit.
	
	(occupiedPercent >= 85) 
		ifTrue: [ 
			newSize := self compactLimit  + (self compactLimit * 20 / 100) truncated.
			self compactLimit: (newSize max: self class maximumCompactLimit) ].

	(occupiedPercent <= 50)
		ifTrue: [ 
			newSize := self compactLimit  - (self compactLimit * 20 / 100) truncated.
			self compactLimit: (newSize max: self class minimumCompactLimit  )]! !

!VOMongoCache methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/13/2011 11:01'!
resetCache
	objects := WeakValueDictionary new.! !

VOError subclass: #VOMongoError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Core'!

!String methodsFor: '*Voyage-Mongo-Core' stamp: 'EstebanLorenzano 10/18/2011 15:25'!
asJSONRegex
	^Dictionary new 
		at: '$regex' put: self;
		at: '$options' put: 'i';
		yourself! !
VOMongoRepository initialize!
